import {BrowserModule} from '@angular/platform-browser';
import {NgModule} from '@angular/core';
import {HttpClientModule} from '@angular/common/http';
import {FormsModule} from '@angular/forms';
import {RouterModule} from '@angular/router';

import {AppComponent} from './app.component';

import * as Components from './components';
import * as Services from './services';
import * as Pipes from './pipes';
import * as Guards from './guards';

@NgModule({
  declarations: [
    AppComponent,
    Components.HeaderComponent,
    Components.LoaderComponent,
    Components.PageProfilComponent,
    Components.PageTrombinoscopeComponent,
    Components.TrombinoscopeCardComponent,
    Pipes.CapitalizePipe,
    Pipes.OrderByFullNamePipe,
    Pipes.SearchPersonPipe,
  ],
  imports: [
    BrowserModule,
    HttpClientModule,
    FormsModule,
    RouterModule.forRoot([
      {path: '', component: Components.PageTrombinoscopeComponent, pathMatch: 'full'},
      {path: 'profil/:id', component: Components.PageProfilComponent, resolve: {person: Guards.ResolvePersonGuard}},
      {path: '**', redirectTo: ''}
    ])
  ],
  providers: [
    Services.PersonService,
    Guards.ResolvePersonGuard
  ],
  bootstrap: [AppComponent]
})
export class AppModule { }
