import {Injectable} from '@angular/core';
import {ActivatedRouteSnapshot, Resolve, Router, RouterStateSnapshot} from '@angular/router';
import {PersonModel} from '../models';
import {PersonService} from '../services';

@Injectable()
export class ResolvePersonGuard implements Resolve<PersonModel> {
  constructor(private personService: PersonService, private router: Router) {
  }

  async resolve(route: ActivatedRouteSnapshot, state: RouterStateSnapshot): Promise<PersonModel> {
    const id = +route.params.id;

    try {
      const person = await this.personService.getPerson(id);
      if (person) {
        return person;
      }
    } catch (e) {

    }

    this.router.navigateByUrl('');
    return null;
  }
}
